/*=========================================================================

Program:   Visualization Toolkit
Module:    $RCSfile: vtkDummyMBReader.h,v $

Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
All rights reserved.
See Copyright.txt or http://www.kitware.com/Copyright.htm for details.

This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notice for more information.

=========================================================================*/


#ifndef __vtkDummyMBReader_h
#define __vtkDummyMBReader_h

#include "vtkUnstructuredGridAlgorithm.h"
#include "vtkMultiBlockDataSetAlgorithm.h"
#include "vtkMultiBlockDataSet.h"
#include "vtkSmartPointer.h"
#include "vector"

#include "vtkStructuredGrid.h"

using namespace std;


class VTK_EXPORT vtkDummyMBReader : public vtkMultiBlockDataSetAlgorithm
{
public:
  static vtkDummyMBReader *New();
  vtkTypeMacro(vtkDummyMBReader,vtkMultiBlockDataSetAlgorithm);

  void PrintSelf(ostream& os, vtkIndent indent);


  vtkSetStringMacro(FileName);
  vtkGetStringMacro(FileName);
  
  void TestProperty(int val);

protected:
  vtkDummyMBReader();
  ~vtkDummyMBReader();

  int RequestData(vtkInformation *, vtkInformationVector **, vtkInformationVector *);

  char *FileName;


  vtkSmartPointer<vtkMultiBlockDataSet>  rootMB;
  bool rootMB_init;

private:
  vtkDummyMBReader(const vtkDummyMBReader&);  // Not implemented.
  void operator=(const vtkDummyMBReader&);  // Not implemented.


  void LoadUnload_Grid(int blockIndex);
   
  int InitMB();   //sets  rootMB structure
    
  int selector;   //catches  the Index block to be Loaded from GUI  (see <IntVectorProperty name="SelectBlock:")
  
  vector<bool>  isLoaded;   // keeps track which block is loaded

  vtkSmartPointer<vtkStructuredGrid>  ReadGrid(int n, double delta , double x , double y, double z);
};

#endif
